/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSInterfaceStyle;

import dstep.appkit.AppKitDefines;
import dstep.appkit.NSResponder;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

import bindings = dstep.appkit.NSInterfaceStyle_bindings;

alias NSUInteger NSInterfaceStyle;

private
{
	NSString NSInterfaceStyleDefault_;
}

NSString NSInterfaceStyleDefault ()
{
	if (NSInterfaceStyleDefault_)
		return NSInterfaceStyleDefault_;

	return NSInterfaceStyleDefault_ = new NSString(bindings.NSInterfaceStyleDefault);
}

enum
{
	NSNoInterfaceStyle = 0,
	NSNextStepInterfaceStyle = 1,
	NSWindows95InterfaceStyle = 2,
	NSMacintoshInterfaceStyle = 3
}

const TNSInterfaceStyle = `

	uint interfaceStyle ()
	{
		return invokeObjcSelf!(uint, "interfaceStyle");
	}

	void setInterfaceStyle (uint interfaceStyle)
	{
		return invokeObjcSelf!(void, "setInterfaceStyle:", uint)(interfaceStyle);
	}

	//mixin ObjcBindMethod!(interfaceStyle, "interfaceStyle");
	//mixin ObjcBindMethod!(setInterfaceStyle, "setInterfaceStyle:");

`;
/*
uint NSInterfaceStyleForKey (NSString key, NSResponder responder)
{
	return Bridge.invokeObjcFunction!(uint, bindings.NSInterfaceStyleForKey, NSString, NSResponder)(key, responder);
}
*/