/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.ats.ScalerStreamTypes;

//import dstep.AvailabilityMacros;
import dstep.applicationservices.ats.SFNTTypes;
import dstep.coreservices.CoreServices;
import dstep.internal.Types;

alias uint scalerStreamTypeFlag;
alias int scalerStreamAction;

enum
{
	cexec68K = 0x00000001,
	truetypeStreamType = 0x00000001,
	type1StreamType = 0x00000002,
	type3StreamType = 0x00000004,
	type42StreamType = 0x00000008,
	type42GXStreamType = 0x00000010,
	portableStreamType = 0x00000020,
	flattenedStreamType = 0x00000040,
	cidType2StreamType = 0x00000080,
	cidType0StreamType = 0x00000100,
	type1CFFStreamType = 0x00000200,
	evenOddModifierStreamType = 0x00008000,
	eexecBinaryModifierStreamType = 0x00010000,
	unicodeMappingModifierStreamType = 0x00020000,
	scalerSpecifcModifierMask = 0x0000F000,
	streamTypeModifierMask = cast(c_long)0xFFFFF000
}

enum
{
	downloadStreamAction = 0,
	asciiDownloadStreamAction = 1,
	fontSizeQueryStreamAction = 2,
	encodingOnlyStreamAction = 3,
	prerequisiteQueryStreamAction = 4,
	prerequisiteItemStreamAction = 5,
	variationQueryStreamAction = 6,
	variationPSOperatorStreamAction = 7
}

enum
{
	selectAllVariations = -1
}

struct scalerPrerequisiteItem
{
	int enumeration;
	int size;
	char* name;
}


struct scalerStream
{
	int prerequisiteQuery;
	int prerequisiteItem;
	SInt32 variationQueryResult;
}


struct scalerStreamData
{
	int hexFlag;
	SInt32 byteCount;
	void* data;
}

