/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CATiledLayer;

import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CALayer;

class CATiledLayer : CALayer
{
	mixin (ObjcWrap);

	static double fadeDuration ()
	{
		return invokeObjcSelfClass!(double, "fadeDuration");
	}

	uint levelsOfDetail ()
	{
		return invokeObjcSelf!(uint, "levelsOfDetail");
	}

	void setLevelsOfDetail (uint arg0)
	{
		return invokeObjcSelf!(void, "setLevelsOfDetail:", uint)(arg0);
	}

	alias setLevelsOfDetail levelsOfDetail;
	
	uint levelsOfDetailBias ()
	{
		return invokeObjcSelf!(uint, "levelsOfDetailBias");
	}

	void setLevelsOfDetailBias (uint arg0)
	{
		return invokeObjcSelf!(void, "setLevelsOfDetailBias:", uint)(arg0);
	}
	
	alias setLevelsOfDetailBias levelsOfDetailBias;

	CGSize tileSize ()
	{
		return invokeObjcSelf!(CGSize, "tileSize");
	}

	void setTileSize (CGSize arg0)
	{
		return invokeObjcSelf!(void, "setTileSize:", CGSize)(arg0);
	}
	
	alias setTileSize tileSize;
}

