/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CVImageBuffer;

import dstep.applicationservices.coregraphics.CGColorSpace;
import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.corefoundation.CFBase;
import dstep.corevideo.CVBuffer;
import dstep.corevideo.CVImageBuffer;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

alias CVBufferRef CVImageBufferRef;

extern (C)
{
	extern
	{
		const CFStringRef kCVImageBufferCGColorSpaceKey;
		const CFStringRef kCVImageBufferCleanApertureKey;
		const CFStringRef kCVImageBufferCleanApertureWidthKey;
		const CFStringRef kCVImageBufferCleanApertureHeightKey;
		const CFStringRef kCVImageBufferCleanApertureHorizontalOffsetKey;
		const CFStringRef kCVImageBufferCleanApertureVerticalOffsetKey;
		const CFStringRef kCVImageBufferPreferredCleanApertureKey;
		const CFStringRef kCVImageBufferFieldCountKey;
		const CFStringRef kCVImageBufferFieldDetailKey;
		const CFStringRef kCVImageBufferFieldDetailTemporalTopFirst;
		const CFStringRef kCVImageBufferFieldDetailTemporalBottomFirst;
		const CFStringRef kCVImageBufferFieldDetailSpatialFirstLineEarly;
		const CFStringRef kCVImageBufferFieldDetailSpatialFirstLineLate;
		const CFStringRef kCVImageBufferPixelAspectRatioKey;
		const CFStringRef kCVImageBufferPixelAspectRatioHorizontalSpacingKey;
		const CFStringRef kCVImageBufferPixelAspectRatioVerticalSpacingKey;
		const CFStringRef kCVImageBufferDisplayDimensionsKey;
		const CFStringRef kCVImageBufferDisplayWidthKey;
		const CFStringRef kCVImageBufferDisplayHeightKey;
		const CFStringRef kCVImageBufferGammaLevelKey;
		const CFStringRef kCVImageBufferYCbCrMatrixKey;
		const CFStringRef kCVImageBufferYCbCrMatrix_ITU_R_709_2;
		const CFStringRef kCVImageBufferYCbCrMatrix_ITU_R_601_4;
		const CFStringRef kCVImageBufferYCbCrMatrix_SMPTE_240M_1995;
		const CFStringRef kCVImageBufferColorPrimariesKey;
		const CFStringRef kCVImageBufferColorPrimaries_ITU_R_709_2;
		const CFStringRef kCVImageBufferColorPrimaries_EBU_3213;
		const CFStringRef kCVImageBufferColorPrimaries_SMPTE_C;
		const CFStringRef kCVImageBufferTransferFunctionKey;
		const CFStringRef kCVImageBufferTransferFunction_ITU_R_709_2;
		const CFStringRef kCVImageBufferTransferFunction_EBU_3213;
		const CFStringRef kCVImageBufferTransferFunction_SMPTE_C;
		const CFStringRef kCVImageBufferChromaLocationTopFieldKey;
		const CFStringRef kCVImageBufferChromaLocationBottomFieldKey;
		const CFStringRef kCVImageBufferChromaLocation_Left;
		const CFStringRef kCVImageBufferChromaLocation_Center;
		const CFStringRef kCVImageBufferChromaLocation_TopLeft;
		const CFStringRef kCVImageBufferChromaLocation_Top;
		const CFStringRef kCVImageBufferChromaLocation_BottomLeft;
		const CFStringRef kCVImageBufferChromaLocation_Bottom;
		const CFStringRef kCVImageBufferChromaLocation_DV420;
		const CFStringRef kCVImageBufferChromaSubsamplingKey;
		const CFStringRef kCVImageBufferChromaSubsampling_420;
		const CFStringRef kCVImageBufferChromaSubsampling_422;
		const CFStringRef kCVImageBufferChromaSubsampling_411;
	}
}

extern (C)
{
	CGSize CVImageBufferGetEncodedSize (CVImageBufferRef imageBuffer);
	CGSize CVImageBufferGetDisplaySize (CVImageBufferRef imageBuffer);
	CGRect CVImageBufferGetCleanRect (CVImageBufferRef imageBuffer);
	CGColorSpaceRef CVImageBufferGetColorSpace (CVImageBufferRef imageBuffer);
}